# Configuration file

"cave decoration chances" {
    # The chances of x decoration spawning, as follows: [Lava stalactites, fiery cave plants, scorched lava stone, skulls, nothing, nothing] [default: [0.5F], [0.5F], [0.5F], [1.0E-2F], [0.0F], [0.0F]]
    S:"Fire Caves Decoration" <
        0.5F
        0.5F
        0.5F
        1.0E-2F
        0.0F
        0.0F
     >

    # The chances of x decoration spawning, as follows: [Iceshrooms, web, icicles, skulls, stalactites, stalactites] [default: [0.3F], [0.2F], [0.6F], [1.0E-2F], [0.5F], [0.0F]]
    S:"Ice Caves Decoration" <
        0.3F
        0.2F
        0.6F
        1.0E-2F
        0.5F
        0.0F
     >

    # The chances of x decoration spawning, as follows: [Flowers and dead shrubs, vines, web, trees, mushrooms, stalactites] [default: [0.7F], [0.6F], [0.15F], [0.4F], [0.4F], [0.3F]]
    S:"Living Caves Decoration" <
        0.7F
        0.6F
        0.15F
        0.4F
        0.4F
        0.3F
     >

    # The chances of x decoration spawning, as follows: [Glowshrooms, vines, web, huge glowshrooms, mushrooms, stalactites] [default: [0.5F], [0.6F], [0.15F], [0.4F], [0.5F], [0.3F]]
    S:"Mushroom Caves Decoration" <
        0.5F
        0.6F
        0.15F
        0.4F
        0.5F
        0.3F
     >

    # The chances of x decoration spawning, as follows: [Vines, web, stalactites, glowshrooms, skulls, nothing] [default: [0.15F], [0.2F], [0.5F], [0.1F], [1.0E-2F], [0.0F]]
    S:"Plain Caves Decoration" <
        0.15F
        0.2F
        0.5F
        0.1F
        1.0E-2F
        0.0F
     >

    # The chances of x decoration spawning, as follows: [Sand stalactites, web, nothing, skulls, stalactites, nothing] [default: [0.5F], [0.2F], [0.5F], [1.0E-2F], [0.5F], [0.0F]]
    S:"Sand Caves Decoration" <
        0.5F
        0.2F
        0.5F
        1.0E-2F
        0.5F
        0.0F
     >

    # The chances of x decoration spawning, as follows: [Glowshrooms, water, vines, web, skulls, stalactites] [default: [0.3F], [0.4F], [0.15F], [0.2F], [1.0E-2F], [0.5F]]
    S:"Water Caves Decoration" <
        0.3F
        0.4F
        0.15F
        0.2F
        1.0E-2F
        0.5F
     >
}


"cave generation modifiers" {
    # Value from -5 to 12, modifies the width of a specific type of caves. Doesn't work with Old Cave Gen option. [range: -12 ~ 12, default: 0]
    I:"Cave Branch Point Width Modifier"=0

    # Value from -3 to 50, manually modifies the cave length in a cave cluster. Doesn't work with Old Cave Gen option. [range: -50 ~ 100, default: 0]
    I:"Cave Length in Cluster Modifier"=0

    # Value from -3 to 12, manually modifies the amount of caves in a cave cluster. Doesn't work with Old Cave Gen option. [range: -12 ~ 50, default: 0]
    I:"Caves in Cluster Modifier"=0

    # Value from -5 to 12, manually modifies the width of a specific type of caves. Doesn't work with Old Cave Gen option. [range: -12 ~ 12, default: 0]
    I:"Circular Cave Room Width Modifier"=0

    # Value from -5 to 12, manually modifies the width of a specific type of caves. Doesn't work with Old Cave Gen option. [range: -12 ~ 12, default: 0]
    I:"Colossal Cave Width Modifier"=0

    # Value from -5 to 12, manually modifies the width of a specific type of caves. Doesn't work with Old Cave Gen option. [range: -12 ~ 12, default: 0]
    I:"Directional Cave Width Modifier"=0

    # Value from -5 to 12, manually modifies the width of a specific type of caves. Doesn't work with Old Cave Gen option. [range: -12 ~ 12, default: 0]
    I:"Maze Cave Width Modifier"=0

    # Value from -5 to 12, manually modifies the width of a specific type of caves. Doesn't work with Old Cave Gen option. [range: -12 ~ 12, default: 0]
    I:"Normal Cave Width Modifier"=0

    # Value from -5 to 12, manually modifies the width of a specific type of caves. Doesn't work with Old Cave Gen option. [range: -12 ~ 12, default: 0]
    I:"Ravine Cave Width Modifier"=0

    # Value from -5 to 12, manually modifies the width of a specific type of caves. Doesn't work with Old Cave Gen option. [range: -12 ~ 12, default: 0]
    I:"Regional Cave Width Modifier"=0

    # Value from -5 to 12, manually modifies the width of a specific type of caves. Doesn't work with Old Cave Gen option. [range: -12 ~ 12, default: 0]
    I:"Vertical Cave Width Modifier"=0
}


"cave types" {
    # If false, other applicable cave types will generate instead. [default: true]
    B:"Generate Fire Caves"=true

    # If false, other applicable cave types will generate instead. [default: true]
    B:"Generate Ice Caves"=true

    # If false, other applicable cave types will generate instead. [default: true]
    B:"Generate Living Caves"=true

    # If false, other applicable cave types will generate instead. [default: true]
    B:"Generate Mushroom Caves"=true

    # If false, other applicable cave types will generate instead. [default: true]
    B:"Generate Sand Caves"=true

    # If false, other applicable cave types will generate instead. [default: true]
    B:"Generate Water Caves"=true

    # Living caves that spawn under swamps not only have some occasional trees and flowers but also dirt, grass etc. [default: false]
    B:"Lush Living Caves"=true
}


entities {
    # -1 is random free ID. Set to something else if you want a fixed entity ID. [range: -1 ~ 1000000, default: -1]
    I:"Brown Spider ID"=-1

    # An option to disable the mod's mobs as a whole. [default: true]
    B:"Enable Mobs"=false

    # -1 is random free ID. Set to something else if you want a fixed entity ID. [range: -1 ~ 1000000, default: -1]
    I:"Glowslime ID"=-1

    # An option to disable the special ability of glowslimes to spawn water. [default: true]
    B:"Glowslimes Spawn Water"=false

    # -1 is random free ID. Set to something else if you want a fixed entity ID. [range: -1 ~ 1000000, default: -1]
    I:"Large Brown Spider ID"=-1

    # How often custom mobs spawn, 1 being the caves are absolutely flooded with them, 10 being the default and 1000 being almost never. [range: 1 ~ 1000, default: 30]
    I:"Mob Spawn Chance"=30

    # -1 is random free ID. Set to something else if you want a fixed entity ID. [range: -1 ~ 1000000, default: -1]
    I:"Small Brown Spider ID"=-1
}


"hard limits" {
    # Allows to set max width of a specific type of cave. Doesn't work with Old Cave Gen option. [range: 0 ~ 1000, default: 1000]
    I:"Cave Branch Point Max Width"=1000

    # Allows to set min width of a specific type of cave. Doesn't work with Old Cave Gen option. [range: 0 ~ 1000, default: 0]
    I:"Cave Branch Point Min Width"=0

    # Allows to set max width of a specific type of cave. Doesn't work with Old Cave Gen option. [range: 0 ~ 1000, default: 1000]
    I:"Circular Cave Room Max Width"=1000

    # Allows to set min width of a specific type of cave. Doesn't work with Old Cave Gen option. [range: 0 ~ 1000, default: 0]
    I:"Circular Cave Room Min Width"=0

    # Allows to set max width of a specific type of cave. Doesn't work with Old Cave Gen option. [range: 0 ~ 1000, default: 1000]
    I:"Colossal Cave Max Width"=1000

    # Allows to set min width of a specific type of cave. Doesn't work with Old Cave Gen option. [range: 0 ~ 1000, default: 0]
    I:"Colossal Cave Min Width"=0

    # Allows to set max width of a specific type of cave. Doesn't work with Old Cave Gen option. [range: 0 ~ 1000, default: 1000]
    I:"Directional Cave Max Width"=1000

    # Allows to set min width of a specific type of cave. Doesn't work with Old Cave Gen option. [range: 0 ~ 1000, default: 0]
    I:"Directional Cave Min Width"=0

    # Turning this on is required for the min-max settings to take effect. Treat this as a 'I know what I'm doing!' switch. [default: false]
    B:"Enable Hard Limits"=false

    # Allows to set max cave length in a cave cluster. Doesn't work with Old Cave Gen option. [range: 0 ~ 1000, default: 1000]
    I:"Max Cave Length in Cluster"=1000

    # Allows to set max amount of caves in a cave cluster. Doesn't work with Old Cave Gen option. [range: 0 ~ 1000, default: 1000]
    I:"Max Caves in Cluster"=1000

    # Allows to set max width of a specific type of cave. Doesn't work with Old Cave Gen option. [range: 0 ~ 1000, default: 1000]
    I:"Maze Cave Max Width"=1000

    # Allows to set min width of a specific type of cave. Doesn't work with Old Cave Gen option. [range: 0 ~ 1000, default: 0]
    I:"Maze Cave Min Width"=0

    # Allows to set min cave length in a cave cluster. Doesn't work with Old Cave Gen option. [range: 0 ~ 1000, default: 0]
    I:"Min Cave Length in Cluster"=0

    # Allows to set min amount of caves in a cave cluster. Doesn't work with Old Cave Gen option. [range: 0 ~ 1000, default: 0]
    I:"Min Caves in Cluster"=0

    # Allows to set max width of a specific type of cave. Doesn't work with Old Cave Gen option. [range: 0 ~ 1000, default: 1000]
    I:"Normal Cave Max Width"=1000

    # Allows to set min width of a specific type of cave. Doesn't work with Old Cave Gen option. [range: 0 ~ 1000, default: 0]
    I:"Normal Cave Min Width"=0

    # Allows to set max width of a specific type of cave. Doesn't work with Old Cave Gen option. [range: 0 ~ 1000, default: 1000]
    I:"Ravine Cave Max Width"=1000

    # Allows to set min width of a specific type of cave. Doesn't work with Old Cave Gen option. [range: 0 ~ 1000, default: 0]
    I:"Ravine Cave Min Width"=0

    # Allows to set max width of a specific type of cave. Doesn't work with Old Cave Gen option. [range: 0 ~ 1000, default: 1000]
    I:"Regional Cave Max Width"=1000

    # Allows to set min width of a specific type of cave. Doesn't work with Old Cave Gen option. [range: 0 ~ 1000, default: 0]
    I:"Regional Cave Min Width"=0

    # Allows to set max width of a specific type of cave. Doesn't work with Old Cave Gen option. [range: 0 ~ 1000, default: 1000]
    I:"Vertical Cave Max Width"=1000

    # Allows to set min width of a specific type of cave. Doesn't work with Old Cave Gen option. [range: 0 ~ 1000, default: 0]
    I:"Vertical Cave Min Width"=0
}


reduction {
    # Allows to make circular cave rooms even less common. [range: 0 ~ 100, default: 0]
    I:"Circular Cave Room Reduction Percentage"=0

    # Allows to make colossal caves even less common. [range: 0 ~ 100, default: 0]
    I:"Colossal Cave Reduction Percentage"=0

    # Dimensions the changes will mostly not affect. [default: [], [], [], [], [], [], [], [], [], [], [], [], [], [], [], [], [], [], [], [], [], []]
    S:"Dimension Blacklist" <
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
     >

    # Allows to make maze caves even less common. [range: 0 ~ 100, default: 0]
    I:"Maze Cave Reduction Percentage"=0

    # Allows to make normal caves even less common. [range: 0 ~ 100, default: 0]
    I:"Normal Cave Reduction Percentage"=0

    # Allows to make normal ravine caves even less common. Note: Ravine caves are different from ravines/caverns! They're not the same thing! [range: 0 ~ 100, default: 0]
    I:"Ravine Cave Reduction Percentage"=0

    # Allows to make regional caves even less common. [range: 0 ~ 100, default: 0]
    I:"Regional Cave Reduction Percentage"=0

    # Allows to make normal vertical even less common. [range: 0 ~ 100, default: 0]
    I:"Vertical Cave Reduction Percentage"=0
}


"world generation" {
    # Biomes that the 'second Y level' will apply to. Replace one or more of the 'Deep Ocean's with another biome to use. [default: [Deep Ocean], [Deep Ocean], [Deep Ocean], [Deep Ocean], [Deep Ocean], [Deep Ocean], [Deep Ocean]]
    S:"Biomes Second Y Level Affects" <
        Deep Ocean
        Deep Ocean
        Deep Ocean
        Deep Ocean
        Deep Ocean
        Deep Ocean
        Deep Ocean
     >

    # Makes EVERY mineshaft corridor spawn with a cave spider spawner and cobwebs. The hardcore version of mineshafts. [default: false]
    B:"Cave Spider Spawner Spawns Always"=false

    # Value from 0 to 50. The default is 1, which is how they generate normally. [range: 0 ~ 50, default: 1]
    I:"Caverns Spawn Frequency Multiplier"=1

    # Value from 0 to 50, 0 totally turning off caves and 50 being a world totally filled with them. The default is 1, which is how they generate in vanilla minecraft. [range: 0 ~ 50, default: 1]
    I:"Caves Spawn Frequency Multiplier"=1

    # The bigger the number, the more likely a stalactite/staalagmite/glowshroom/other decoration will spawn for every block of a cave. [range: 0.0 ~ 1.0, default: 0.8]
    S:"Decoration Density Modifier"=0.8

    # Don't know about you, but I hate it when a random source block sets a forest on fire. [default: false]
    B:"Disable Lava Source Block Gen"=true

    # Disables vanilla, non-custom cavern spawning completely. [default: false]
    B:"Disable Vanilla Caverns"=false

    # Prevents vanilla from spawning patches of dirt underground. Please note this will likely have no effect on vanilla gen replacers, such as CoFH Core. [default: false]
    B:"Disable Vanilla Underground Dirt"=false

    # Don't know about you, but I find random water falling down on lava lakes in fire caves pretty annoying and immersion-ruining. Note: Does NOT affect 'Water Flooded Caves', you can turn that off separately. [default: false]
    B:"Disable Water Source Block Gen"=true

    # Surprise! (Only keep reading if you hate surprises)(Randomly (but rarely) applies blindness below y=35 and plays a sound). [default: true]
    B:Effects=false

    # Makes mineshafts spawn less chaotically and in better mineshaft systems. [default: true]
    B:"Enable Better Mineshafts"=true

    # Improved sand generation. [default: true]
    B:"Enable Better Sand Generation"=true

    # Gives option to disable cave spider spawners in mineshafts from spawning. [default: true]
    B:"Enable Cave Spider Spawner Spawn"=true

    # Replaces the vanilla caverns with custom. [default: true]
    B:"Enable Caverns Replacer"=true

    # Gives option to disable dungeons from spawning. [default: true]
    B:"Enable Dungeon Spawn"=true

    # Gives option to disable mineshafts from spawning. [default: true]
    B:"Enable Mineshafts Spawn"=true

    # Applies the nether stalactites, plants etc. in worldgen to the nether as well. A bit wacky, so off by default. [default: false]
    B:"Enable Nether Decoration"=false

    # Gives option to disable strongholds from spawning. [default: true]
    B:"Enable Stronghold Spawn"=true

    # Gives option to disable villages from spawning. [default: true]
    B:"Enable Village Spawn"=true

    # Disables liquid source block and lake spawn changes and toggles for stucture spawns, for better mod compatibility. If something conflicts with another mod, the first thing you should try disabling is this. The second is 'Separate Flooded Y Level'. [default: true]
    B:"Enable World Population Changes"=false

    # Makes the world underground a HUGE cavern system. A bit extreme, not many will like it, but the option is there. (Note: Does not work with Old Cave Gen option) [default: false]
    B:"Exteme Cave Gen"=false

    # Note: This will only affect caves that *can* be big. There are going to be some small caves even if you turn this to 100. Note 2: This is NOT percentages. 100 does not mean caves have 100% chance to be big, it simply means they're 100 'x' more likely to be big. [range: 0 ~ 100, default: 0]
    I:"Extra Mega Cave Chance"=10

    # 1 - Lava, 2 - Water. NOTE: As many things, doesn't support old cave gen option. [range: 1 ~ 2, default: 1]
    I:"Filled Caves Spawn Mechanism"=1

    # Air blocks under this point will always be replaced with water/lava (depends on the other config settings). NOTE: As many things, doesn't support old cave gen option. [range: 1 ~ 256, default: 4]
    I:"Filled Caves Y Level"=4

    # Allows to control lava lake frequencies. The less the number, the more frequently they spawn, so 1 = they spawn more oftenly, 10000 = close to never. [range: 1 ~ 100000, default: 30]
    I:"Lava Lakes Chance"=30

    # Big caves frequency multiplier that only works with 'Old Cave Gen' as true. [range: 0 ~ 50, default: 1]
    I:"Old Big Caves Spawn Frequency Multiplier"=1

    # Instead of using TMCU4 cave gen, uses TMCU2 cave gen. [default: false]
    B:"Old Cave Gen"=false

    # If set to true, changes in 'disable lava source block gen' and 'disable water source block gen' will only apply if underground. [default: false]
    B:"Only Disable Source Gen Underground"=false

    # Gives option to disable scattered features from spawning. [default: false]
    B:"Plain World"=false

    # Makes it possible to burn cobwebs with torches/flint and steel. Backport of the 1.14+ Realistic Cobwebs mod. Will disable itself if 'serveronly' is enabled. [default: true]
    B:"Realistic Cobwebs"=true

    # As an attempt to create something similar to subterranean waters, some caves in and around 'deep ocean's have a separate fixed average Y level below which they're flooded with water. [default: true]
    B:"Separate Flooded Y Level"=false

    # Custom items, blocks etc. will not be registered effectively allowing the mod to be server-only. Will disable Realistic Cobwebs config option. Note: Because of https://github.com/MinecraftForge/FML/issues/510 vanilla clients can't join. Nothing I can do, if you know a way around this please notify me. [default: false]
    B:"Server Only"=false

    # Stalactites, stalagmites, vines etc. will not spawn if you turn this off. [default: true]
    B:"Spawn Cave Decorations"=true

    # If living caves are enabled, trees can spawn in them. The closer this number to 0, the more likely a tree will be dead, the closer to 1, the more likely it will be alive. [range: 0.0 ~ 1.0, default: 0.5]
    S:"Tree Type Spawn Change"=0.5

    # Allows to control underground lava lake frequencies. The less the number, the more frequently they spawn, so 1 = they spawn more oftenly, 10000 = close to never. [range: 1 ~ 100000, default: 24]
    I:"Underground Lava Lakes Chance"=24

    # How often a lily will try to spawn underground. 1F does *not* mean every underground water block will have lily. [range: 0.0 ~ 1.0, default: 0.5]
    S:"Underground Lilies Spawn Change"=0.5

    # 1 - Glow in mushroom caves, normal everywhere else. 2 - Glow everywhere. 3 - Normal everywhere. (To turn off completely, use 'Chance' setting). [range: 1 ~ 3, default: 1]
    I:"Underground Lilies Spawn Mode"=1

    # Allows to control underground water lake frequencies. The less the number, the more frequently they spawn, so 1 = they spawn more oftenly, 10000 = close to never. [range: 1 ~ 100000, default: 24]
    I:"Underground Water Lakes Chance"=24

    # Some water-flooded caves will spawn. if you think it's not immersive but annoying, you can turn it off :p [default: true]
    B:"Water Flooded Caves"=false

    # Allows to control water lake frequencies. The less the number, the more frequently they spawn, so 1 = they spawn more oftenly, 10000 = close to never. [range: 1 ~ 100000, default: 12]
    I:"Water Lakes Chance"=12
}


